'DateAndTime as merged class (subclass of Date with seconds) (easier for use, e.g., in databases)'!

Date subclass: #DateAndTime
	instanceVariableNames: 'seconds '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Magnitudes'!
!DateAndTime commentStamp: 'stp 8/15/2000 00:42' prior: 0!
DateAndTime is a Date subclass with a seconds instVar. It can create a Time instance lazily.

Structure:
 seconds		SmallInt -- seconds within the day

Try: 		DateAndTime dateAndTimeNow explore
!
]style[(158 34 1)f1,f1cred;,f1cblack;!


!DateAndTime methodsFor: 'accessing' stamp: 'stp 8/15/2000 00:38'!
hours
	"Answer the number of hours the receiver represents."

	^self time hours! !

!DateAndTime methodsFor: 'accessing' stamp: 'stp 8/15/2000 00:37'!
minutes
	"Answer the number of minutes the receiver represents."

	^self time minutes! !

!DateAndTime methodsFor: 'accessing' stamp: 'stp 8/15/2000 00:37'!
seconds
	"Answer the receiver's 'seconds'."

	^seconds
"	^time seconds"! !

!DateAndTime methodsFor: 'accessing' stamp: 'stp 8/15/2000 00:37'!
seconds: sec
	"Set the receiver's 'seconds'."

	seconds := sec! !

!DateAndTime methodsFor: 'accessing' stamp: 'stp 8/15/2000 00:37'!
time
	"Answer the receiver's 'time'."

	^Time fromSeconds: seconds
"	^time"! !

!DateAndTime methodsFor: 'accessing' stamp: 'stp 8/15/2000 00:37'!
time: anObject
	"Set the receiver's instance variable 'time' to be anObject."

"	time := anObject"! !


!DateAndTime methodsFor: 'comparing' stamp: 'stp 8/15/2000 00:27'!
< aDATime 
	"Answer whether aTime is earlier than the receiver."

	^(super < aDATime) and: [self seconds < aDATime asSeconds]! !

!DateAndTime methodsFor: 'comparing' stamp: 'stp 8/15/2000 00:29'!
= aDATime 
	"Answer whether aTime is = the receiver."

	^self species = aDATime species
		ifFalse: [false]
		ifTrue: [(super < aDATime) 
			and: [self seconds < aDATime asSeconds]]! !


!DateAndTime methodsFor: 'printing' stamp: 'stp 8/15/2000 00:43'!
printOn: aStream

	self printOn: aStream format: #(1 2 3 $. 1 2).		"print terse date format"
	aStream space.
	self time print24: true on: aStream! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DateAndTime class
	instanceVariableNames: ''!

!DateAndTime class methodsFor: 'instance creation' stamp: 'stp 8/15/2000 00:36'!
dateAndTimeNow
	"Answer a two-element Array of (Date today, Time now)."
	"DateAndTime dateAndTimeNow"

	| secondCount inst |
	secondCount _ Time primSecondsClock.
	inst _ self fromSeconds: secondCount.
	inst seconds: secondCount \\ 86400.
"	inst time: (Time fromSeconds: secondCount \\ 86400)."
	^inst! !

!DateAndTime class methodsFor: 'instance creation' stamp: 'stp 8/15/2000 00:49'!
from: secondCount
	"Answer a two-element Array of (Date today, Time now)."
	"DateAndTime from: 3143636853 -->  13.8.00 16:27:33"

	|  inst |
	inst _ self fromSeconds: secondCount.
	inst seconds: secondCount \\ 86400.
"	inst time: (Time fromSeconds: secondCount \\ 86400)."
	^inst! !

!DateAndTime class methodsFor: 'instance creation' stamp: 'stp 8/15/2000 00:45'!
now
	"Answer an object that encapsulates (Date today, Time now)."
	"DateAndTime now"

	| secondCount inst |
	secondCount _ Time primSecondsClock.
	inst _ self fromSeconds: secondCount.
	inst seconds: secondCount \\ 86400.
	^inst! !
