'Extent-from-user for new windows; assumes Mark''s layouts. Do [Preferences enable: #userPlacement]'!

!Debugger methodsFor: 'initialize' stamp: 'stp 8/14/2000 18:21'!
buildMorphicNotifierLabelled: label message: messageString
	| notifyPane window contentTop extentV |
	window _ (PreDebugWindow labelled: label) model: self.

	"Preferences optionalMorphicButtons" true
		ifTrue:
			[contentTop _ 0.2.
			window addMorph: (self buttonRowForPreDebugWindow: window)
				frame: (0@0 corner: 1 @ contentTop).
			extentV _ 156]
		ifFalse:
			[extentV _ 116.
			contentTop _ 0].
	notifyPane _ PluggableTextMorph on: self text: nil accept: nil
		readSelection: nil menu: #debugProceedMenu:.
	notifyPane editString: messageString; askBeforeDiscardingEdits: false.
	window addMorph: notifyPane frame: (0@contentTop corner: 1@1).

	^ window openInWorld: window currentWorld extent: 450 @ extentV abs: true! !

!Debugger methodsFor: 'initialize' stamp: 'stp 8/14/2000 17:26'!
initialExtent
	^ (Display extent / (2 @ 1.2)) truncated! !

!Debugger methodsFor: 'initialize' stamp: 'stp 8/14/2000 17:23'!
openFullMorphicLabel: labelString
        | window aListMorph codeTopOffset aTextMorph listFraction
codeFraction |
        listFraction _ 0.3.
        codeFraction _ 0.7.
        self expandStack.
        window _ (SystemWindow labelled: labelString) model: self.
        aListMorph _ PluggableListMorph on: self list: #contextStackList
                        selected: #contextStackIndex changeSelected:
#toggleContextStackIndex:
                        menu: #contextStackMenu:shifted: keystroke:
#contextStackKey:from:.
        aListMorph menuTitleSelector: #messageListSelectorTitle.
        window addMorph: aListMorph
                layout: (Layout
                        leftFraction: 0 offset: 0
                        topFraction: 0 offset: 0
                        rightFraction: 1 offset: 0
                        bottomFraction: listFraction offset: 0).

        Preferences useAnnotationPanes
                ifFalse:
                        [codeTopOffset _ 0]
                ifTrue:
                        [aTextMorph _ PluggableTextMorph on: self
                                        text: #annotation accept: nil
                                        readSelection: nil menu: nil.
                        aTextMorph askBeforeDiscardingEdits: false.
                        window addMorph: aTextMorph
                                layout: (Layout
                                        leftFraction: 0 offset: 0
                                        topFraction: listFraction offset: 0
                                        rightFraction: 1 offset: 0
                                        bottomFraction: listFraction offset:
Preferences textRowHeight).
                        codeTopOffset _ Preferences textRowHeight].

        Preferences optionalButtons ifTrue:
                [window addMorph: self optionalButtonRow
                        layout: (Layout
                                leftFraction: 0 offset: 0
                                topFraction: listFraction offset:
codeTopOffset
                                rightFraction: 1 offset: 0
                                bottomFraction: listFraction offset:
codeTopOffset + Preferences buttonRowHeight).
                codeTopOffset _ codeTopOffset + Preferences
buttonRowHeight].
        window addMorph: (PluggableTextMorph on: self
                        text: #contents accept: #contents:notifying:
                        readSelection: #contentsSelection menu:
#codePaneMenu:shifted:)
                layout: (Layout
                        leftFraction: 0 offset: 0
                        topFraction: listFraction offset: codeTopOffset
                        rightFraction: 1 offset: 0
                        bottomFraction: codeFraction offset: 0).
        window addMorph: (PluggableListMorph on: self receiverInspector
list: #fieldList
                        selected: #selectionIndex changeSelected:
#toggleIndex:
                        menu: #fieldListMenu: keystroke:
#inspectorKey:from:)
                layout: (Layout
                        leftFraction: 0 offset: 0
                        topFraction: codeFraction offset: 0
                        rightFraction: 0.2 offset: 0
                        bottomFraction: 1 offset: 0).
        window addMorph: (PluggableTextMorph on: self receiverInspector
                        text: #contents accept: #accept:
                        readSelection: #contentsSelection menu:
#codePaneMenu:shifted:)
                layout: (Layout
                        leftFraction: 0.2 offset: 0
                        topFraction:  codeFraction offset: 0
                        rightFraction: 0.5 offset: 0
                        bottomFraction: 1 offset: 0).
        window addMorph: (PluggableListMorph on: self
contextVariablesInspector list: #fieldList
                        selected: #selectionIndex changeSelected:
#toggleIndex:
                        menu: #fieldListMenu: keystroke:
#inspectorKey:from:)
                layout: (Layout
                        leftFraction: 0.5 offset: 0
                        topFraction: codeFraction offset: 0
                        rightFraction: 0.7 offset: 0
                        bottomFraction: 1 offset: 0).
        window addMorph: (PluggableTextMorph on: self
contextVariablesInspector
                        text: #contents accept: #accept:
                        readSelection: #contentsSelection menu:
#codePaneMenu:shifted:)
                layout: (Layout
                        leftFraction: 0.7 offset: 0
                        topFraction: codeFraction offset: 0
                        rightFraction: 1 offset: 0
                        bottomFraction: 1 offset: 0).

        ^ window openInWorld! !

!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'stp 04/01/1999 04:35'!
constrainFrame: aRectangle min: minimumSize
	"Constrain aRectangle, to the minimum and maximum size for this window"

	^ aRectangle origin extent: (aRectangle extent max: minimumSize)! !

!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'stp 8/14/2000 17:55'!
getFrameExt: initExtent
	"Ask the user to designate a rectangular area in which
	the receiver should be displayed."
	"RealEstateAgent getFrame"

	| minFrame minimumSize |
	minimumSize := initExtent.   "(Display extent // 2) truncated."
	minFrame _ Cursor origin showWhile: 
		[(Sensor cursorPoint extent: minimumSize) newRectFrom:
			[:f | Sensor cursorPoint extent: minimumSize]].
	^ Cursor corner showWhile:
		[minFrame newRectFrom:
			[:f | self constrainFrame: (f origin corner: Sensor cursorPoint) min: minimumSize]]! !

!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'stp 8/14/2000 17:53'!
initialFrameFor: aView initialExtent: initialExtent world: aWorld
	"Find a plausible initial screen area for the supplied view, which should be a StandardSystemView, taking into account the 'reverseWindowStagger' Preference, the size needed, and other windows currently on the screen."
	"Preferences enable: #userPlacement"
	"Preferences disable: #userPlacement"

	| allOrigins screenRight screenBottom putativeOrigin putativeFrame allowedArea staggerOrigin otherFrames |
	Preferences userPlacement
		ifTrue: [^self  getFrameExt: initialExtent].
	Preferences reverseWindowStagger ifTrue:
		[^ self strictlyStaggeredInitialFrameFor: aView initialExtent: initialExtent world: aWorld].

	allowedArea _ self maximumUsableAreaInWorld: aWorld.
	screenRight _ allowedArea right.
	screenBottom _ allowedArea bottom.

	otherFrames _ Smalltalk isMorphic
		ifTrue: [(SystemWindow windowsIn: aWorld satisfying: [:w | w isCollapsed not])
					collect: [:w | w bounds]]
		ifFalse: [ScheduledControllers scheduledWindowControllers
				select: [:aController | aController view ~~ nil]
				thenCollect: [:aController | aController view isCollapsed
								ifTrue: [aController view expandedFrame]
								ifFalse: [aController view displayBox]]].

	allOrigins _ otherFrames collect: [:f | f origin].
	(self standardPositionsInWorld: aWorld) do:  "First see if one of the standard positions is free"
		[:aPosition | (allOrigins includes: aPosition)
			ifFalse:
				[^ (aPosition extent: initialExtent) squishedWithin: allowedArea]].

	staggerOrigin _ (self standardPositionsInWorld: aWorld) first.  "Fallback: try offsetting from top left"
	putativeOrigin _ staggerOrigin.

	[putativeOrigin _ putativeOrigin + StaggerOffset.
	putativeFrame _ putativeOrigin extent: initialExtent.
	(putativeFrame bottom < screenBottom) and:
					[putativeFrame right < screenRight]]
				whileTrue:
					[(allOrigins includes: putativeOrigin)
						ifFalse:
							[^ (putativeOrigin extent: initialExtent) squishedWithin: allowedArea]].
	^ (self scrollBarSetback @ self screenTopSetback extent: initialExtent) squishedWithin: allowedArea! !

!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'stp 8/14/2000 18:21'!
initialFrameFor: aView initialExtent: initialExtent world: aWorld abs: bool
	"Find a plausible initial screen area for the supplied view, which should be a StandardSystemView, taking into account the 'reverseWindowStagger' Preference, the size needed, and other windows currently on the screen."
	"Preferences enable: #userPlacement"
	"Preferences disable: #userPlacement"

	| allOrigins screenRight screenBottom putativeOrigin putativeFrame allowedArea staggerOrigin otherFrames |
	(bool not and: [Preferences userPlacement])
		ifTrue: [^self  getFrameExt: initialExtent].
	Preferences reverseWindowStagger ifTrue:
		[^ self strictlyStaggeredInitialFrameFor: aView initialExtent: initialExtent world: aWorld].

	allowedArea _ self maximumUsableAreaInWorld: aWorld.
	screenRight _ allowedArea right.
	screenBottom _ allowedArea bottom.

	otherFrames _ Smalltalk isMorphic
		ifTrue: [(SystemWindow windowsIn: aWorld satisfying: [:w | w isCollapsed not])
					collect: [:w | w bounds]]
		ifFalse: [ScheduledControllers scheduledWindowControllers
				select: [:aController | aController view ~~ nil]
				thenCollect: [:aController | aController view isCollapsed
								ifTrue: [aController view expandedFrame]
								ifFalse: [aController view displayBox]]].

	allOrigins _ otherFrames collect: [:f | f origin].
	(self standardPositionsInWorld: aWorld) do:  "First see if one of the standard positions is free"
		[:aPosition | (allOrigins includes: aPosition)
			ifFalse:
				[^ (aPosition extent: initialExtent) squishedWithin: allowedArea]].

	staggerOrigin _ (self standardPositionsInWorld: aWorld) first.  "Fallback: try offsetting from top left"
	putativeOrigin _ staggerOrigin.

	[putativeOrigin _ putativeOrigin + StaggerOffset.
	putativeFrame _ putativeOrigin extent: initialExtent.
	(putativeFrame bottom < screenBottom) and:
					[putativeFrame right < screenRight]]
				whileTrue:
					[(allOrigins includes: putativeOrigin)
						ifFalse:
							[^ (putativeOrigin extent: initialExtent) squishedWithin: allowedArea]].
	^ (self scrollBarSetback @ self screenTopSetback extent: initialExtent) squishedWithin: allowedArea! !

!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'stp 8/14/2000 18:22'!
initialFrameFor: aView world: aWorld
	"Find a plausible initial screen area for the supplied view.  See called method."

	^ self initialFrameFor: aView initialExtent: aView initialExtent world: aWorld abs: false! !

!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'stp 8/14/2000 18:18'!
initialFrameFor: aView world: aWorld abs: bool
	"Find a plausible initial screen area for the supplied view.  See called method."

	^ self initialFrameFor: aView initialExtent: aView initialExtent world: aWorld abs: bool! !


!SystemWindow methodsFor: 'open/close' stamp: 'stp 8/14/2000 18:18'!
openInWorld: aWorld extent: extent
	"This msg and its callees result in the window being activeOnlyOnTop"
	self position: (RealEstateAgent initialFrameFor: self world: aWorld abs: true) topLeft; extent: extent.
	aWorld addMorph: self.
	self activate.
	aWorld startSteppingSubmorphsOf: self.! !

!SystemWindow methodsFor: 'open/close' stamp: 'stp 8/14/2000 18:19'!
openInWorld: aWorld extent: extent abs: bool
	"This msg and its callees result in the window being activeOnlyOnTop"
	self position: (RealEstateAgent initialFrameFor: self world: aWorld abs: bool) topLeft; extent: extent.
	aWorld addMorph: self.
	self activate.
	aWorld startSteppingSubmorphsOf: self! !

Preferences enable: #userPlacement!

